#pragma once

#include "metal-base.h"
#include "metal-device.h"

namespace rhi::metal {

class QueryPoolImpl : public QueryPool
{
public:
    RefPtr<DeviceImpl> m_device;
    NS::SharedPtr<MTL::CounterSampleBuffer> m_counterSampleBuffer;

    ~QueryPoolImpl();

    Result init(DeviceImpl* device, const QueryPoolDesc& desc);

    virtual SLANG_NO_THROW Result SLANG_MCALL getResult(GfxIndex index, GfxCount count, uint64_t* data) override;
};

} // namespace rhi::metal
